<p align="center">
  <img src="https://weforge.xyz/partisan/Pulse/raw/branch/main/data/icon.svg" alt="Pulse Icon" width="64" height="64">
</p>

<p align="center" style="font-size: 32px;">
  <strong>Pulse</strong>
</p>

<p align="center">
Redirecting outgoing calls to E2EE apps.
</p>

---

<p align="center">
  <a href="https://apt.izzysoft.de/fdroid/index/apk/partisan.weforge.xyz.pulse">
    <img src="https://weforge.xyz/partisan/Pulse/raw/branch/main/data/IzzyOnDroidButton.svg" alt="Download on IzzyOnDroid" width="255" height="75">
  </a>
  &nbsp;&nbsp;&nbsp;&nbsp;
  <a href="https://weforge.xyz/partisan/Pulse/src/branch/main/README.md#using-obtainium">
    <img src="https://weforge.xyz/partisan/Pulse/raw/branch/main/data/OptainiumButton.png" alt="Download using Optainium" width="255" height="75">
  </a>
</p>

---

<p align="center">
  <strong>Screenshots</strong>
</p>

<p align="center">
  <span>
    <img src="https://weforge.xyz/partisan/Pulse/raw/branch/main/fastlane/metadata/android/en-US/images/phoneScreenshots/1.png" alt="Main screen" height="500" style="border-radius: 8px;">
  </span>
  &nbsp;&nbsp;&nbsp;&nbsp;
  <span>
    <img src="https://weforge.xyz/partisan/Pulse/raw/branch/main/fastlane/metadata/android/en-US/images/phoneScreenshots/2.png" alt="Redirecting popup" height="500" style="border-radius: 8px;">
  </span>
  &nbsp;&nbsp;&nbsp;&nbsp;
  <span>
    <img src="https://weforge.xyz/partisan/Pulse/raw/branch/main/fastlane/metadata/android/en-US/images/phoneScreenshots/3.png" alt="Redirecting popup" height="500" style="border-radius: 8px;">
  </span>
  &nbsp;&nbsp;&nbsp;&nbsp;
  <span>
    <img src="https://weforge.xyz/partisan/Pulse/raw/branch/main/fastlane/metadata/android/en-US/images/phoneScreenshots/4.png" alt="Redirecting popup" height="500" style="border-radius: 8px;">
  </span>
</p>

# Features

- Material You design  
- Popup with cancel option  
- Extensive settings panel:
  - Toggle per-service support  
  - Redirection only on Wi-Fi/Data  
  - Allowlist specific contacts  
  - Change per-service priority  
  - Customize popup position, animation, and duration  
  - ...

# Supports

- Signal  
- Telegram  
- Threema  
- WhatsApp  

# How to Install

## Using Droid-ify (or other F-Droid client)

[Install Droid-ify from their page](https://droidify.eu.org/)

In the app, search for "Pulse" and install it.

*Pulse uses the IzzyOnDroid repo. Some F-Droid clients, such as F-Droid itself, do not include it by default. Please add the IzzyOnDroid repo: https://apt.izzysoft.de/fdroid/repo*

## Using Obtainium

[Install Obtainium](https://github.com/ImranR98/Obtainium/blob/main/README.md)

In the “Add App” screen:

1. Add the following URL: https://weforge.xyz/partisan/Pulse  
2. In **Override Source**, select **Forgejo (Codeberg)**  
3. Tap the “Add” button at the very top, and you’re done!

## Install directly

Go to the [Releases page](https://weforge.xyz/partisan/Pulse/releases) and download the latest file with the following format: `app-release.apk`.

Install it, and you’re done!

*Please note that when installing directly, the app will not receive automatic updates.*

# Permissions

- `ACCESS_NETWORK_STATE` – check connectivity  
- `CALL_PHONE` – make a call via messenger  
- `READ_CONTACTS` – check if contact has a messenger  
- `READ_PHONE_NUMBERS` – detect outgoing call  
- `SYSTEM_ALERT_WINDOW` – show redirecting popup and launch from background  
- `INTERNET` – check connectivity and verify donates  

Currently all of the permissions are required.

# License

[![GNU GPLv3 Image](https://www.gnu.org/graphics/gplv3-127x51.png)](https://www.gnu.org/licenses/gpl-3.0.en.html)

This application is Free Software: You can use, study share and improve it at your will.
Specifically you can redistribute and/or modify it under the terms of the
[GNU General Public License v3](https://www.gnu.org/licenses/gpl.html) as published by the Free
Software Foundation.

## Icon Credit

Icon based on "Pulse 53" from the [Flare Dashed Icons](https://www.svgrepo.com/svg/450484/pulse) collection by [Taras Shypka](https://www.svgrepo.com/author/Taras%20Shypka/).
Licensed under the [Public Domain](https://www.svgrepo.com/page/licensing/#PD).

## Original Author

[This software](https://github.com/x13a/Red) was originally developed by [x13a](https://github.com/x13a), but it has been archived by the owner on Jun 22, 2022.